;;--------------------------------------------------------------------------*
;;  Dateiname: sample.lsp
;;  Version  : 1.0
;;  Datum    :
;;  Author   : Gt
;;--------------------------------------------------------------------------*
;;  Modulbeschreibung: Bohrung und Senkungen                                *
;;                                                                          *
;;                                                                          *
;;                                                                          *
;;--------------------------------------------------------------------------*
;;  Hilfsmittel:                                                            *
;;                                                                          *
;;--------------------------------------------------------------------------*
;;  Zugehoerige Moduln:                                                     *
;;     Name     |    Kurzbeschreibung                                       *
;;              |                                                           *
;;              |                                                           *
;;--------------------------------------------------------------------------*
;;  Wichtige Informationen:                                                 *
;;--------------------------------------------------------------------------*
;;  Anderungsverzeichnis:                                                   *
;;   Version   |  Datum   |   Autor    |  Beschreibung                      *
;;             |          |            |                                    *
;;             |          |            |                                    *
;;--------------------------------------------------------------------------*

;;--------------------------------------------------------------------------*
;;     in-packages                                                          *
;;--------------------------------------------------------------------------*

(in-package :MEINEFIRMA)

;;--------------------------------------------------------------------------*
;;     use-packages                                                         *
;;--------------------------------------------------------------------------*

(use-package :OLI)
(use-package :custom)

;;--------------------------------------------------------------------------*
;;     global variables                                                     *
;;--------------------------------------------------------------------------*

;;--------------------------------------------------------------------------*
;;     export                                                               *
;;--------------------------------------------------------------------------*
#|
(export '(

         )
)
|#
;;***************************************************************************
;;     DIALOGS                                                              *
;;***************************************************************************

(sd-create-menu "meinefirma-bohrung"
  :title "MEINEFIRMA-Bohrung"
  :contents
  '(
    (:buttonBox "bohrung"
     :title "Bohrungen"
     :buttons
     (
      (meinefirma-bohrung-durch-dialog :label "Durchgang")
      (meinefirma-bohrung-sack-dialog :label "Sackloch")
     )
    )
    (:buttonBox "senkungen-zyl"
     :title "Senkungen zyl."
     :buttons
     (
      (meinefirma-senkung-din84-dialog :label "DIN 84")
      (meinefirma-senkung-din912-dialog :label "DIN 912")
      (meinefirma-senkung-din6912-dialog :label "DIN 6912")
      )
    )
    (:buttonBox "senkungen-keg"
     :title "Senkungen keg."
     :buttons
     (
      (meinefirma-senkung-din963-dialog :label "DIN 963")
      (meinefirma-senkung-din7991-dialog :label "DIN 7991")
     )
    )
   )
:helpAction '(sd-display-url (format nil "~a#Bohrungen" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*

(sd-add-menu-button "meinefirma-bohrung"
    :label "MEINEFIRMA-Bohrg."
    :parent '("TASK" "SolidDesigner")
    :mapmenu "meinefirma-bohrung"
)

;;--------------------------------------------------------------------------*

(sd-defdialog 'meinefirma-bohrung-durch-dialog
:dialog-title "Durchgang"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bdm   :value-type :positive-number
           :prompt-text "Bohrungsdurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-bohrung-table"
                            :position '(
                            "MEINEFIRMA-BOHRUNG-DURCH-DIALOG-OPTIONS-OPT-CONT-BDM-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-bohrung-table")
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Bohrung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-bohrung-durch teil pnt rcht bdm)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-bohrung-durch teil pnt rcht bdm))
:help-action '(sd-display-url (format nil "~a#Bohrung-Durchgang" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*

(sd-defdialog 'meinefirma-bohrung-sack-dialog
:dialog-title "Sackloch"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bdm   :value-type :positive-number
           :prompt-text "Bohrungsdurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-bohrung-table"
                            :position '(
                            "MEINEFIRMA-BOHRUNG-SACK-DIALOG-OPTIONS-OPT-CONT-BDM-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-bohrung-table")
    )
    (tief
            :value-type :positive-number
            :prompt-text " Bohrungstiefe angeben"
            :title "Tiefe"
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Bohrung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-bohrung-sack teil pnt rcht bdm tief)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-bohrung-sack teil pnt rcht bdm tief))
:help-action '(sd-display-url (format nil "~a#Bohrung-Sackloch" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*


(sd-defdialog 'meinefirma-senkung-din84-dialog
:dialog-title "DIN 84"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bez   :value-type :string
           :prompt-text "Gewindedurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-senkung-din84-table"
                            :position '(
                            "MEINEFIRMA-SENKUNG-DIN84-DIALOG-OPTIONS-OPT-CONT-BEZ-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-senkung-din84-table")
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Senkung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-senkung-din84 teil pnt rcht bez)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-senkung-din84 teil pnt rcht bez))
:help-action '(sd-display-url (format nil "~a#Senkungen-DIN84" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*

(sd-defdialog 'meinefirma-senkung-din912-dialog
:dialog-title "DIN 912"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bez   :value-type :string
           :prompt-text "Gewindedurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-senkung-din912-table"
                            :position '(
                            "MEINEFIRMA-SENKUNG-DIN912-DIALOG-OPTIONS-OPT-CONT-BEZ-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-senkung-din912-table")
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Senkung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-senkung-din912 teil pnt rcht bez)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-senkung-din912 teil pnt rcht bez))
:help-action '(sd-display-url (format nil "~a#Senkungen-DIN912" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*

(sd-defdialog 'meinefirma-senkung-din6912-dialog
:dialog-title "DIN 912"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bez   :value-type :string
           :prompt-text "Gewindedurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-senkung-din6912-table"
                            :position '(
                            "MEINEFIRMA-SENKUNG-DIN6912-DIALOG-OPTIONS-OPT-CONT-BEZ-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-senkung-din6912-table")
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Senkung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-senkung-din6912 teil pnt rcht bez)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-senkung-din6912 teil pnt rcht bez))
:help-action '(sd-display-url (format nil "~a#Senkungen-DIN6912" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*

(sd-defdialog 'meinefirma-senkung-din963-dialog
:dialog-title "DIN 912"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bez   :value-type :string
           :prompt-text "Gewindedurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-senkung-din963-table"
                            :position '(
                            "MEINEFIRMA-SENKUNG-DIN963-DIALOG-OPTIONS-OPT-CONT-BEZ-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-senkung-din963-table")
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Senkung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-senkung-din963 teil pnt rcht bez)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-senkung-din963 teil pnt rcht bez))
:help-action '(sd-display-url (format nil "~a#Senkungen-DIN963" *meinefirma-hilfe-datei*))
)

;;--------------------------------------------------------------------------*

(sd-defdialog 'meinefirma-senkung-din7991-dialog
:dialog-title "DIN 912"
;;:dialog-control :sequential
:variables
  '(
    (teil :value-type :part
          :prompt-text "Teil fuer Bearbeitung angeben."
          :title "Teil"
    )
    (bez   :value-type :string
           :prompt-text "Gewindedurchmesser angeben."
           :title "Durchm."
           :show-input-tool (sd-show-display-table "meinefirma-senkung-din7991-table"
                            :position '(
                            "MEINEFIRMA-SENKUNG-DIN7991-DIALOG-OPTIONS-OPT-CONT-BEZ-TB"
                            :leftcenter -10 -20)
                            )
           :hide-input-tool (sd-hide-display-table "meinefirma-senkung-din7991-table")
    )
    (pnt  :value-type :point-3d
          :prompt-text "Startpunkt fuer Bearbeitung angeben."
          :title "Start"
    )
    (rcht
            :value-type :measure-direction
            :prompt-text "Richtung der Senkung angeben"
            :title "Richtung"
    )
    (next
            :push-action (sd-call-cmds (next-action))
    )
   )
:local-functions
  '((next-action ()
     (meinefirma-bohre-senkung-din7991 teil pnt rcht bez)
     (setq pnt nil)
    )
   )
:ok-action
   '(sd-call-cmds (meinefirma-bohre-senkung-din7991 teil pnt rcht bez))
:help-action '(sd-display-url (format nil "~a#Senkungen-DIN7991" *meinefirma-hilfe-datei*))
)

;;***************************************************************************
;;     TABELS                                                               *
;;***************************************************************************

(sd-create-display-table "meinefirma-bohrung-table"
     :tableTitle             "Bohrung"
     :logicalTable           "meinefirma-bohrung-logtable"
;;     :columns     '(:Zl :Bez :Gdm :Gstg :Bdm :SkdmA :SkdmB :SkwB :SkdmK :FdmK :SktH :SktJ :SktK :Typ)
     :columns     '(:Bez :Bdm)
     :applyColumns           '(:bdm)
     :selectionMode          :single-row
     :applyAction            :default
)

(sd-filter-display-table "meinefirma-bohrung-table"
     :column :Zl
     :test1 :not-less
     :value1 1
     :test2 :not-greater
     :value2 21
)

;;--------------------------------------------------------------------------*

(sd-create-display-table "meinefirma-senkung-din84-table"

     :tableTitle             "DIN 84"
     :logicalTable           "meinefirma-bohrung-logtable"
;;     :columns     '(:Zl :Bez :Gdm :Gstg :Bdm :SkdmA :SkdmB :SkwB :SkdmK :FdmK :SktH :SktJ :SktK :Typ)
     :columns     '(:Bez :Bdm :SkdmK :SktH)
     :applyColumns           '(:bez)
     :selectionMode          :single-row
     :applyAction            :default-tokens
)

(sd-filter-display-table "meinefirma-senkung-din84-table"
     :column :Zl
     :test1 :not-less
     :value1 1
     :test2 :not-greater
     :value2 15
)

;;--------------------------------------------------------------------------*

 (sd-create-display-table "meinefirma-senkung-din912-table"
     :tableTitle             "DIN 912"
     :logicalTable           "meinefirma-bohrung-logtable"
;;     :columns     '(:Zl :Bez :Gdm :Gstg :Bdm :SkdmA :SkdmB :SkwB :SkdmK :FdmK :SktH :SktJ :SktK :Typ)
     :columns     '(:Bez :Bdm :SkdmK :SktK)
     :applyColumns           '(:bez)
     :selectionMode          :single-row
     :applyAction            :default-tokens
)

(sd-filter-display-table "meinefirma-senkung-din912-table"
     :column :Zl
     :test1 :not-less
     :value1 3
     :test2 :not-greater
     :value2 19
)

;;--------------------------------------------------------------------------*

(sd-create-display-table "meinefirma-senkung-din6912-table"
     :tableTitle             "DIN 6912"
     :logicalTable           "meinefirma-bohrung-logtable"
;;     :columns     '(:Zl :Bez :Gdm :Gstg :Bdm :SkdmA :SkdmB :SkwB :SkdmK :FdmK :SktH :SktJ :SktK :Typ)
     :columns     '(:Bez :Bdm :SkdmK :SktJ)
     :applyColumns           '(:bez)
     :selectionMode          :single-row
     :applyAction            :default-tokens
)

(sd-filter-display-table "meinefirma-senkung-din6912-table"
     :column :Zl
     :test1 :not-less
     :value1 7
     :test2 :not-greater
     :value2 17
)

;;--------------------------------------------------------------------------*

(sd-create-display-table "meinefirma-senkung-din963-table"
     :tableTitle             "DIN 963"
     :logicalTable           "meinefirma-bohrung-logtable"
;;     :columns     '(:Zl :Bez :Gdm :Gstg :Bdm :SkdmA :SkdmB :SkwB :SkdmK :FdmK :SktH :SktJ :SktK :Typ)
     :columns     '(:Bez :Bdm :SkdmA :SkwB)
     :applyColumns           '(:bez)
     :selectionMode          :single-row
     :applyAction            :default-tokens
)

(sd-filter-display-table "meinefirma-senkung-din963-table"
     :column :Zl
     :test1 :not-less
     :value1 1
     :test2 :not-greater
     :value2 14
)

;;--------------------------------------------------------------------------*

(sd-create-display-table "meinefirma-senkung-din7991-table"
     :tableTitle             "DIN 7991"
     :logicalTable           "meinefirma-bohrung-logtable"
;;     :columns     '(:Zl :Bez :Gdm :Gstg :Bdm :SkdmA :SkdmB :SkwB :SkdmK :FdmK :SktH :SktJ :SktK :Typ)
     :columns     '(:Bez :Bdm :SkdmB :SkwB)
     :applyColumns           '(:bez)
     :selectionMode          :single-row
     :applyAction            :default-tokens
)

(sd-filter-display-table "meinefirma-senkung-din7991-table"
     :column :Zl
     :test1 :not-less
     :value1 6
     :test2 :not-greater
     :value2 15
)

;;***************************************************************************
;;     FUNCTIONS                                                            *
;;***************************************************************************

(defun meinefirma-bohre-bohrung-durch (teil startpunkt richtung bdm)
 (let (br p1 akt_wp)
  (setf br (/ bdm 2))

  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (circle :cen_rad p1 br) ;; Durchgangsbohrung positionieren

  (punch :parts (sd-inq-obj-pathname teil) :keep_wp :no) ;; Durchgangsbohrung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

(defun meinefirma-bohre-bohrung-sack (teil startpunkt richtung bdm tief)
 (let (br bt p1 p2 akt_wp)
  (setf br (/ bdm 2))
  (setf bt (+ tief (/ br (tan (/ (* pi 120) 360)))))
  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf p2 (make-gpnt2d :x bt :y 0))
  (setf p3 (make-gpnt2d :x tief :y br))
  (setf p4 (make-gpnt2d :x 0 :y br))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (position_wp :current :rotate :axis :v :rotation_angle (/ (* pi -90) 180))
  (polygon p1 p2 p3 p4 :close) ;;Bohrung zeichnen
  (bore :parts (sd-inq-obj-pathname teil) :axis :u :rotation_angle (/ (* pi 360) 180) :keep_wp :no) ;;Bohrung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

(defun meinefirma-bohre-senkung-din84 (teil startpunkt richtung bez)
 (let ( tab bdm skdmh fdmh skth br sr fr ft p1 p2 p3 p4 p5 p6 akt_wp)

  (setf tab (format nil "meinefirma-bohrung-logtable"))
  (setf bdm (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :bdm))
  (setf skdmh (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skdmk))
  (setf fdmh (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :fdmk))
  (setf skth (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skth))
  (setf br (/ bdm 2))
  (setf sr (/ skdmh 2))
  (if (= fdmh 0)
      (progn
        (setf fr (/ (+ br sr) 2))
        (setf ft skth)
      );;progn
      (progn
        (setf fr (/ fdmh 2))
        (setf ft (+ (- fr br) skth))
      );;progn
  );;if
  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf p2 (make-gpnt2d :x ft :y 0))
  (setf p3 (make-gpnt2d :x ft :y br))
  (setf p4 (make-gpnt2d :x skth :y fr))
  (setf p5 (make-gpnt2d :x skth :y sr))
  (setf p6 (make-gpnt2d :x 0 :y sr))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (circle :cen_rad p1 br) ;; Durchgangsbohrung positionieren

  (punch :parts (sd-inq-obj-pathname teil) :keep_profile :no) ;; Durchgangsbohrung bohren
  (position_wp :current :rotate :axis :v :rotation_angle (/ (* pi -90) 180))
  (polygon p1 p2 p3 p4 p5 p6 :close) ;;Senkung zeichnen
  (bore :parts (sd-inq-obj-pathname teil) :axis :u :rotation_angle (/ (* pi 360) 180) :keep_wp :no) ;;Senkung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

(defun meinefirma-bohre-senkung-din912 (teil startpunkt richtung bez)
 (let ( tab bdm skdmk fdmk sktk br sr fr ft p1 p2 p3 p4 p5 p6 akt_wp)

  (setf tab (format nil "meinefirma-bohrung-logtable"))
  (setf bdm (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :bdm))
  (setf skdmk (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skdmk))
  (setf fdmk (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :fdmk))
  (setf sktk (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :sktk))
  (setf br (/ bdm 2))
  (setf sr (/ skdmk 2))
  (if (= fdmk 0)
      (progn
        (setf fr (/ (+ br sr) 2))
        (setf ft sktk)
      );;progn
      (progn
        (setf fr (/ fdmk 2))
        (setf ft (+ (- fr br) sktk))
      );;progn
  );;if
  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf p2 (make-gpnt2d :x ft :y 0))
  (setf p3 (make-gpnt2d :x ft :y br))
  (setf p4 (make-gpnt2d :x sktk :y fr))
  (setf p5 (make-gpnt2d :x sktk :y sr))
  (setf p6 (make-gpnt2d :x 0 :y sr))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (circle :cen_rad p1 br) ;; Durchgangsbohrung positionieren

  (punch :parts (sd-inq-obj-pathname teil) :keep_profile :no) ;; Durchgangsbohrung bohren
  (position_wp :current :rotate :axis :v :rotation_angle (/ (* pi -90) 180))
  (polygon p1 p2 p3 p4 p5 p6 :close) ;;Senkung zeichnen
  (bore :parts (sd-inq-obj-pathname teil) :axis :u :rotation_angle (/ (* pi 360) 180) :keep_wp :no) ;;Senkung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

(defun meinefirma-bohre-senkung-din6912 (teil startpunkt richtung bez)
 (let ( tab bdm skdmj fdmj sktj br sr fr ft p1 p2 p3 p4 p5 p6 akt_wp)

  (setf tab (format nil "meinefirma-bohrung-logtable"))
  (setf bdm (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :bdm))
  (setf skdmj (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skdmk))
  (setf fdmj (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :fdmk))
  (setf sktj (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :sktj))
  (setf br (/ bdm 2))
  (setf sr (/ skdmj 2))
  (if (= fdmj 0)
      (progn
        (setf fr (/ (+ br sr) 2))
        (setf ft sktj)
      );;progn
      (progn
        (setf fr (/ fdmj 2))
        (setf ft (+ (- fr br) sktj))
      );;progn
  );;if
  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf p2 (make-gpnt2d :x ft :y 0))
  (setf p3 (make-gpnt2d :x ft :y br))
  (setf p4 (make-gpnt2d :x sktj :y fr))
  (setf p5 (make-gpnt2d :x sktj :y sr))
  (setf p6 (make-gpnt2d :x 0 :y sr))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (circle :cen_rad p1 br) ;; Durchgangsbohrung positionieren

  (punch :parts (sd-inq-obj-pathname teil) :keep_profile :no) ;; Durchgangsbohrung bohren
  (position_wp :current :rotate :axis :v :rotation_angle (/ (* pi -90) 180))
  (polygon p1 p2 p3 p4 p5 p6 :close) ;;Senkung zeichnen
  (bore :parts (sd-inq-obj-pathname teil) :axis :u :rotation_angle (/ (* pi 360) 180) :keep_wp :no) ;;Senkung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

(defun meinefirma-bohre-senkung-din963 (teil startpunkt richtung bez)
 (let ( tab bdm skdma skwa br sr bt p1 p2 p3 p4 p5 p6 akt_wp)

  (setf tab (format nil "meinefirma-bohrung-logtable"))
  (setf bdm (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :bdm))
  (setf skdma (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skdma))
  (setf skwa (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skwb))
  (setf br (/ bdm 2))
  (setf sr (/ skdma 2))
  (setf bt (/ sr (tan (/ (* pi skwa) 360))))
  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf p2 (make-gpnt2d :x bt :y 0))
  (setf p3 (make-gpnt2d :x 0 :y sr))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (circle :cen_rad p1 br) ;; Durchgangsbohrung positionieren

  (punch :parts (sd-inq-obj-pathname teil) :keep_profile :no) ;; Durchgangsbohrung bohren
  (position_wp :current :rotate :axis :v :rotation_angle (/ (* pi -90) 180))
  (polygon p1 p2 p3 :close) ;;Senkung zeichnen
  (bore :parts (sd-inq-obj-pathname teil) :axis :u :rotation_angle (/ (* pi 360) 180) :keep_wp :no) ;;Senkung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

(defun meinefirma-bohre-senkung-din7991 (teil startpunkt richtung bez)
 (let ( tab bdm skdma skwa br sr bt p1 p2 p3 p4 p5 p6 akt_wp)

  (setf tab (format nil "meinefirma-bohrung-logtable"))
  (setf bdm (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :bdm))
  (setf skdmb (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skdmb))
  (setf skwb (sd-read-logical-table-cell tab
                                              :pList  `(:bez ,bez)
                                              :column :skwb))
  (setf br (/ bdm 2))
  (setf sr (/ skdmb 2))
  (setf bt (/ sr (tan (/ (* pi skwb) 360))))
  (setf p1 (make-gpnt2d :x 0 :y 0))
  (setf p2 (make-gpnt2d :x bt :y 0))
  (setf p3 (make-gpnt2d :x 0 :y sr))
  (setf akt_wp (sd-inq-curr-wp)) ;; aktuelle Arbeitsebene

  (create_workplane :new)
  (position_wp :current :pt_dir :origin startpunkt :normal (car richtung))
  (circle :cen_rad p1 br) ;; Durchgangsbohrung positionieren

  (punch :parts (sd-inq-obj-pathname teil) :keep_profile :no) ;; Durchgangsbohrung bohren
  (position_wp :current :rotate :axis :v :rotation_angle (/ (* pi -90) 180))
  (polygon p1 p2 p3 :close) ;;Senkung zeichnen
  (bore :parts (sd-inq-obj-pathname teil) :axis :u :rotation_angle (/ (* pi 360) 180) :keep_wp :no) ;;Senkung bohren
  (if akt_wp (current_wp akt_wp) nil)
 );; let
)

;;--------------------------------------------------------------------------*

