;;--------------------------------------------------------------*
;;                                                              *
;; Initialisierungsdatei meinefirma-Makros                            *
;;                                                              *
;; Dateiname    :               start.lsp                       *
;;                                                              *
;; 21.01.1999                   Gt                              *
;;                                                              *
;;--------------------------------------------------------------*

;;--------------------------------------------------------------------------*
;;     in-packages                                                          *
;;--------------------------------------------------------------------------*

(in-package :MEINEFIRMA)

;;--------------------------------------------------------------------------*
;;     use-packages                                                         *
;;--------------------------------------------------------------------------*

(use-package :OLI)
(use-package :custom)

;;--------------------------------------------------------------*
;; Globale Variablen und Verzeichnisse; bitte anpassen
;;--------------------------------------------------------------*

(defvar *meinefirma-verzeichnis*)
(defvar *meinefirma-makro-verzeichnis*)
(defvar *meinefirma-hilfe-verzeichnis*)
(defvar *meinefirma-hilfe-datei*)
(defvar *meinefirma-tmp-verzeichnis*)
(defvar *meinefirma-homedrive*)
(defvar *meinefirma-homepath*)
(defvar *meinefirma-username*)

(if (eql (sd-inq-platform) :hp-ux)
  (setf *meinefirma-verzeichnis* "/users/meinefirma")
  (setf *meinefirma-verzeichnis* "x:/users/meinefirma")
);;if
(setf *meinefirma-makro-verzeichnis* (format nil "~a/SD/lisp" *meinefirma-verzeichnis*))
(setf *meinefirma-hilfe-verzeichnis* (format nil "~a/hilfe" *meinefirma-makro-verzeichnis*))
(setf *meinefirma-hilfe-datei* (format nil "~a/meinefirma_help.htm" *meinefirma-hilfe-verzeichnis*))
(setf *meinefirma-tmp-verzeichnis* (format nil "~a/tmp" *meinefirma-makro-verzeichnis*))

(setf *meinefirma-homedrive* (sd-sys-getenv "HOMEDRIVE"))
(setf *meinefirma-homepath* (sd-sys-getenv "HOMEPATH"))
(setf *meinefirma-username* (sd-sys-getenv "USERNAME"))
(export '(
         *meinefirma-verzeichnis*
         *meinefirma-makro-verzeichnis*
         *meinefirma-hilfe-verzeichnis*
         *meinefirma-hilfe-datei*
         *meinefirma-tmp-verzeichnis*
         *meinefirma-homedrive*
         *meinefirma-homepath*
         *meinefirma-username*
         )
);;export

;;--------------------------------------------------------------*
;; Initialisierung
;;--------------------------------------------------------------*

;;--------------------------------------------------------------*
;; LISP-Dateien
;;--------------------------------------------------------------*


(load (format nil "~a/sample.dat" *meinefirma-makro-verzeichnis*))
(load (format nil "~a/sample.lsp" *meinefirma-makro-verzeichnis*))


(use-package :MEINEFIRMA)

